<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN"
    "http://www.w3.org/TR/html4/strict.dtd">
<html lang="de">
    <head>
        <title>phpHyphenator</title>
        <meta http-equiv="content-type" content="text/html; charset=UTF-8">
        <style type="text/css">
            body1 {
                width:30%;
                margin-left:35%;
                margin-right:35%;
            }
            .text {
                text-align:justify;
								border:1px solid #ddd;
            }
            .text2 {
								border:1px solid #ddd;
            }
            td{
            		vertical-align : top;
            }
        </style>
        <script src="../Hyphenator.js" type="text/javascript"></script>
        <script type="text/javascript">
        	Hyphenator.config({
        		displaytogglebox : true,
        		minwordlength : 4,
<?
	switch ($_REQUEST["hyphen"]) {
		case '173' :	break;		//default
		case 'shy' :	echo "hyphenchar : '&shy;'"; break;		
		case 'vshy':	echo "hyphenchar : '&amp;shy;'"; break;		
		case '-'   :	echo "hyphenchar : '-'"; break;		
	}
		

?>
        	});

 		       	Hyphenator.run();

	       </script>


    </head>
    <body>
<?php

/*
	This example file shows how to use web hyphenation
	in 3 easy steps.
		
	STEP 1: ENCODING
	Use UTF-8 encoding:
*/	

//	header('content-type: text/html; charset=utf-8');

/*
	STEP 2: SETTINGS
	Settings must be applied before including the
	"hyphenation.php". These are the default values:

	$GLOBALS["language"] = "de";
		Values: de, en, fr, nl
		
	$GLOBALS["path_to_patterns"] = "patterns/";
		Where the patterns are located.
		
	$GLOBALS["dictionary"] = "dictionary.txt";
		You can create a text file with special words
		and those hyphenations line by line.
		Use the / to mark a hyphenation.
		For example: hyphe/nation
		Be sure to use UNIX line encoding LF
		
	$GLOBALS["hyphen"] = "&shy;";
		Entity or single character for hyphenation.
	
	$GLOBALS["leftmin"] = 2;
	$GLOBALS["rightmin"] = 2;
	$GLOBALS["charmin"] = 2;
	$GLOBALS["charmax"] = 10;
		Minimum characters on left / right side and
		characters length of a word.
		
	$GLOBALS["exclude_tags"] = array("code", "pre", "script", "style");
		HTML tags to exclude from hyphenation.
	
	
	STEP 3: INCLUDING HYPHENATION.PHP
*/

	include("hyphenation.php");
//	include("Kopie von hyphenation.php");

/*	
	After including the file, hyphenation is available as
	normal function.
*/
	
	$text = 'Silbentrennung 	';

	$text = 'Silbentrennung	Als Pionier auf dem Gebiet der Kleinstkreditvergabe hat Muhammad Yunus, damals Dekan der Wirtschaftsfakultät von Chittagong, begonnen, kleinen Gewerbetreibenden in den Dörfern Bangladeschs mit aus unserer Sicht winzigen Summen zu helfen. Ausgangspunkt seiner Aktivitäten ist die Konfrontation mit einer katastrophalen Hungersnot in Bangladesch, die ihn und seine StudentInnen veranlasst, den wissenschaftlichen Elfenbeinturm zu verlassen, um bei den Menschen in den Dörfern nach wirtschaftsnahen und Selbsthilfe fördernden Lösungsmöglichkeiten für die Verbesserung der Lebensverhältnisse zu suchen. Am Beispiel von Sufia Begum - die ihre Familie mit der Herstellung von Bambusstühlen mühevoll am Leben erhält - erfährt Muhammad Yunus, 	';
	$text = 'Dies ist ein Beispiel, wie Silbentrennung funktionieren kann. 

Der Text in der linken Spalte, zeigt den unformatierten Text aus der Eingabebox oben. Der Text hat keinerlei Zeilenumbrüche. Es entsteht ein Flatterrand, der vor allem bei langen Worten, wie Donaudampfschifffahrtskapitänsmütze oder etwa Feuerwehrrettungshubschrauberlandeplatz, blöd aussehen kann. 

Damit dies nicht passiert, sieht HTML vor, das sogenannte Softhyphen (shy) in Worte einzufügen. Dieses ist nicht sichtbar, wie in der mittleren und rechten Spalte zu sehen ist, hat aber den Effekt am Zeilenende. 

Allerdings ist es für einen Redakteur mühsam, in jedes Wort an der richtigen Trennstelle ein Trennzeichen oder eben ein shy einzufügen. Insbesondere wenn die Spaltenbreite, wie auf dieser Seite, variieren kann. Probieren Sie es aus. Verändern Sie die Breite dieses Fensters.

Um das Problem zu lösen, gibt es einen genialen Ansatz. Mehr dazu auf <a href="http://code.google.com/p/hyphenator/wiki/2AutomatischeSilbentrennungMitJS" target="_blank">Hyphenator.js</a>.

Dieser Ansatz wurde von Mathias Nater in Javascript programmiert. Das bedeutet, unformatierter Text, wird beim User im Browser formatiert. Das Ergebnis sieht man in der rechten Spalte. Ist Javascript nicht aktiviert, wird nichts formatiert. Wie sich das Script auf langsamen Handhelds wie Handy oder iPad verhält, ist unklar.

Aus diesem Grund, gibt es eine 2. Lösung, die den Text bereits auf dem Server mit den passenden Softhyphen versieht. Dazu wurde die Hyphenator.js Lösung in PHP umprogrammiert. Das Ergebnis zeigt die mittlere Spalte. 

In diesem Beispiel kann das Trennzeichen frei gewählt werden. \'chr(173)\' fügt das Trennzeichen mit dem ASCII-Wert 173 ein. \'shy\' fügt \'&amp;shy;\' ein und \'shy sichtbar\' macht das Trennzeichen in den Spalten sichtbar. Entsprechend funktioniert \'-\'.

Geben Sie Ihren eigenen Text ein und wählen \'shy sichtbar\', dann können Sie den Text in der mittleren oder rechten Spalte kopieren und in ihrer eigenen Seite verwenden. Probieren Sie es aus. Markieren Sie \'shy sichtbar\' und klicken auf \'Absenden\'. Dann markieren und kopieren Sie den Text in der mittleren Spalte. Fügen Sie diesen Text in das Textfeld ein und klicken wieder auf Absenden. 

In der linken Spalte sehen Sie jetzt den vorformatierten Text ohne das phpHyphenator oder Hyphenator.js etwas gemacht haben. 


';

?>
<h1>Beispiel zur Anwendung des phpHyphenator</h1>
<form action="example.php" method="post" accept-charset="UTF-8">
<table sborder=0 cellpadding=0 cellspacing=0>
  <colgroup>
    <col width="10px">
    <col width="300px">
    <col width="10px">
    <col width="400px">
  </colgroup>
<tr><td></td><td>Geben Sie hier Ihren eigenen Text ein. Der Text erscheint nach klicken des Absenden Buttons in den Spalten unten.</td><td></td>
	<td><textarea name="text" cols="50" rows="5"><?if($_REQUEST["text"] == ''){ echo $text;}else {echo $_REQUEST["text"];} ?></textarea></td>
</tr>
<tr><td></td><td>Wählen Sie ein Trennzeichen</td><td></td>
	<td>
    <input type="radio" name="hyphen" value="173" <? if($_REQUEST["hyphen"] == '173' or $_REQUEST["hyphen"] == '') echo 'checked'; ?> > chr(173)
    <input type="radio" name="hyphen" value="shy" <? if($_REQUEST["hyphen"] == 'shy') echo 'checked'; ?> > shy unsichtbar
    <input type="radio" name="hyphen" value="vshy" <? if($_REQUEST["hyphen"] == 'vshy') echo 'checked'; ?> > shy sichtbar
    <input type="radio" name="hyphen" value="-" <? if($_REQUEST["hyphen"] == '-') echo 'checked'; ?> > - Zeichen
	</td>
</tr>
<tr><td></td><td></td><td></td>
	<td><br />
<input type="submit" value=" Absenden "></td>
</tr>
</table>

</form>
<br />
<br />
<table sborder=0 cellpadding=0 cellspacing=0 width="100%">
	  <colgroup>
    <col width="5%">
    <col width="25%">
    <col width="5%">
    <col width="25%">
    <col width="5%">
    <col width="25%">
    <col width="10%">
  </colgroup>
	<tr><td></td><td><b>Text unformatiert</b></td><td></td><td><b>formatiert mit phpHyphenator</b></td><td></td><td><b>formatiert mit Hyphenator.js</b></td><td></td></tr>
	<tr><td></td>
	
<?	
	if($_REQUEST["text"] != '')$text = $_REQUEST["text"];

	$text = str_replace("\n","<br />",$text);

	switch ($_REQUEST["hyphen"]) {
		case '173' :	$hyphen = iconv("ISO-8859-1", "UTF-8", chr(173));break;		//default
		case 'shy' :	$hyphen = '&shy;';  break;		
		case 'vshy':	$hyphen = '&amp;shy;'; break;		
		case '-'   :	$hyphen = '-'; break;		
	}

	echo '<td><p class="text2" lang="de">'.$text.'</p></td>';
	echo "<td></td>";
	echo '<td><p class="text" lang="de">'.hyphenation($text).'</p></td>';
	echo "<td></td>";
	echo '<td><p class="hyphenate text" lang="de">'.$text.'</p></td>';
?>
		<td></td>
	</tr>
</table>


    </body>
</html>